using System;

namespace Telecomunicacao
{
	/// <summary>
	/// 
	/// </summary>
	public sealed class Factory
	{
		private Factory()
		{
		}

		public static ICartao CreateCartaoService()
		{
			return new CartaoImpl();
		}

		public static IChamada CreateChamadaService()
		{
			return new ChamadaImpl();
		}	

		public static ICliente CreateClienteService()
		{
			return new ClienteImpl();
		}

		public static ITarifario CreateTarifarioService()
		{
			return new TarifarioImpl();
		}
		
		public static IUtilizador CreateUtilizadorService()
		{
			return new UtilizadorImpl();
		}	
	}
}
