using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Telecomunicacao;

namespace TelecomunicacaoW
{
	/// <summary>
	/// Summary description for FormTarifario.
	/// </summary>
	public class FormTarifario : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox textTarifarioNome;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOK;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.DataGrid dgDetalhes;
		private System.Windows.Forms.TextBox textTarifarioComissao;

		private long _idTarifario;
		public long Tarifario
		{
			set { _idTarifario = value; }
			get { return _idTarifario; }
		}

		public FormTarifario()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textTarifarioComissao = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.textTarifarioNome = new System.Windows.Forms.TextBox();
			this.dgDetalhes = new System.Windows.Forms.DataGrid();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dgDetalhes)).BeginInit();
			this.SuspendLayout();
			// 
			// textTarifarioComissao
			// 
			this.textTarifarioComissao.Location = new System.Drawing.Point(88, 47);
			this.textTarifarioComissao.Name = "textTarifarioComissao";
			this.textTarifarioComissao.Size = new System.Drawing.Size(184, 20);
			this.textTarifarioComissao.TabIndex = 33;
			this.textTarifarioComissao.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 15);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(72, 23);
			this.label7.TabIndex = 34;
			this.label7.Text = "Nome";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 47);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(72, 23);
			this.label9.TabIndex = 35;
			this.label9.Text = "Comissao";
			// 
			// textTarifarioNome
			// 
			this.textTarifarioNome.Location = new System.Drawing.Point(88, 15);
			this.textTarifarioNome.Name = "textTarifarioNome";
			this.textTarifarioNome.Size = new System.Drawing.Size(184, 20);
			this.textTarifarioNome.TabIndex = 32;
			this.textTarifarioNome.Text = "";
			// 
			// dgDetalhes
			// 
			this.dgDetalhes.DataMember = "";
			this.dgDetalhes.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgDetalhes.Location = new System.Drawing.Point(16, 80);
			this.dgDetalhes.Name = "dgDetalhes";
			this.dgDetalhes.Size = new System.Drawing.Size(600, 232);
			this.dgDetalhes.TabIndex = 28;
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(544, 320);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 37;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// btnOK
			// 
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(448, 320);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 36;
			this.btnOK.Text = "Ok";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// FormTarifario
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 350);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.textTarifarioComissao);
			this.Controls.Add(this.textTarifarioNome);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.dgDetalhes);
			this.Name = "FormTarifario";
			this.Text = "Tarifario";
			this.Load += new System.EventHandler(this.FormTarifario_Load);
			((System.ComponentModel.ISupportInitialize)(this.dgDetalhes)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			// copiar valores eliminando espaos em branco
			
			try
			{
				double comissao = double.Parse(textTarifarioComissao.Text);
				string nome  = textTarifarioNome.Text.Trim();

				ITarifario c = Factory.CreateTarifarioService();
				StatusEnum status = StatusEnum.NOT_OK;
				if (_idTarifario == -1)
				{
					status = c.Criar(UserSettings.Username, UserSettings.Password, nome, comissao, (DataSet)dgDetalhes.Tag, out _idTarifario);
				}
				else
				{
					status = c.Alterar(UserSettings.Username, UserSettings.Password,_idTarifario, nome, comissao, (DataSet)dgDetalhes.Tag);
				}

				if (status != StatusEnum.OK)
				{
					MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + status, "TelecomunicacaoW", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				else
				{
					this.DialogResult = DialogResult.OK;
				}
			}
			catch (FormatException /* ex */)
			{
				MessageBox.Show("Por favor introduza o custo num formato correcto", "TelecomunicacaoW", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
		
		}

		private void FormTarifario_Load(object sender, System.EventArgs e)
		{
			//
			// procurar os detalhes
			//
			// IProduct c = new Product();
			ITarifario c = Factory.CreateTarifarioService();
			DataSet ds = c.GetByID(UserSettings.Username, UserSettings.Username, _idTarifario);

			//
			// apresentar o tarifario se mencionado
			//
			if (ds.Tables["Tarifario"].Rows.Count != 0)
			{
				DataRow r = ds.Tables["Tarifario"].Rows[0];

				textTarifarioNome.Text = (string)r["nome"];
				textTarifarioComissao.Text= r["comissao"].ToString();

				//
				// efectuar databind
				//
				dgDetalhes.DataMember = "Tarifa";
				dgDetalhes.DataSource = ds;
			}
		}
	}
}
