using System;
using System.Collections;
using System.Text;
using System.Data;
using System.Data.OleDb;

namespace Telecomunicacao
{
    public interface IUtilizador
    {        
        /// <summary>
        /// devolve informao de um utilizador
        /// </summary>
        /// <param name="user"> nome do utilizador vlido </param>
        /// <param name="pwd"> password do utilizador </param>
        /// <param name="name"> nome do utilizador a ver a informao, valido </param>
        /// <pre> utilizador valido tanto do que esta a requerer a informao
        /// bem como do que se pretende a informao</pre>
        /// <post> no altera os dados </post>
        /// <returns> retorna os dados de um utilizador </returns>
        DataSet GetByName(string user, string pwd, string name);

        /// <summary>
        /// verifica se um utilizador  valido
        /// </summary>
        /// <param name="user">nome do utilizador </param>
        /// <param name="pwd"> password do utilizador </param>
        /// <param name="tipo">tipo de utilizador </param>
        /// <pre> </pre>
        /// <post> nao altera os dados </post>
        /// <returns> retorna se um utilizador  vlido</returns>
        bool Valido(string user, string pwd, out TipoUtilizador tipo);

        /// <summary>
        /// devolve o tipo de utilizador
        /// </summary>
        /// <param name="user"> nome do utilizador </param>
        /// <param name="pwd"> password do utilizador </param>
        /// <pre> utilizador valido </pre>
        /// <post> nao altera os dados</post>
        /// <returns> retorna o tipo de utilizador</returns>
        TipoUtilizador Tipo(string user, string pwd);
    }

    internal class UtilizadorImpl : IUtilizador
    {
        public UtilizadorImpl()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        /// devolve informao de um utilizador
        /// </summary>
        /// <param name="user"> nome do utilizador vlido </param>
        /// <param name="pwd"> password do utilizador </param>
        /// <param name="name"> nome do utilizador a ver a informao, valido </param>
        /// <pre> utilizador valido tanto do que esta a requerer a informao
        /// bem como do que se pretende a informao</pre>
        /// <post> no altera os dados </post>
        /// <returns> retorna os dados de um utilizador </returns>
        public DataSet GetByName(string user, string pwd, string name)
        {
            DataSet ds = null;
            OleDbConnection conn = null;

            try
            {
                //
                // criar objecto DataSet
                //
                ds = new DataSet();

                //
                // criar objecto de conexo  base de dados e abrir a conexo
                //
                conn = new OleDbConnection(UtilDB.CONN);
                conn.Open();

                //
                // criar um Datadapter para executar o comando e devolver o dataset
                //
                string sSqlCmd = "Select * From Utilizador Where nome = '" + name + "'";
                OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);

                //
                // executar o comando e preencher um Dataset
                //
                oAdapter.Fill(ds, "Utilizador");
            }
            catch (OleDbException ex)
            {
                //
                // tratar a excepo!!!!
                //
                System.Console.WriteLine("EXCEPO no mtodo 'Utilizador.GetByName': " + ex.Message);
                ds = null;
            }
            finally
            {
                //
                // fechar a conexo
                //
                if (conn.State == ConnectionState.Open)
                    conn.Close();
            }

            return ds;
        }

        /// <summary>
        /// verifica se um utilizador  valido
        /// </summary>
        /// <param name="user">nome do utilizador </param>
        /// <param name="pwd"> password do utilizador </param>
        /// <param name="tipo"> tipo de utilizador </param>
        /// <pre> </pre>
        /// <post> nao altera os dados </post>
        /// <returns> retorna se um utilizador  vlido</returns>
        public bool Valido(string user, string pwd, out TipoUtilizador tipo)
        {
            if (UtilDB.ValidateUser(user, pwd, out tipo) == StatusEnum.INVALID_LOGIN)
                return false;
            else
                return true;
        }

        /// <summary>
        /// devolve o tipo de utilizador
        /// </summary>
        /// <param name="user"> nome do utilizador </param>
        /// <param name="pwd"> password do utilizador </param>
        /// <pre> utilizador valido </pre>
        /// <post> nao altera os dados</post>
        /// <returns> retorna o tipo de utilizador</returns>
        public TipoUtilizador Tipo(string user, string pwd)
        {
            TipoUtilizador tipo;

            Valido(user, pwd, out tipo);

            return tipo;

            /*jf antes de 2007.01.03
            if (!Valido(user, pwd))
            {
                return TipoUtilizador.DESCONHECIDO;
            }
                DataSet ds;
                if ((ds = GetByName(user,pwd,user)) != null)
                {
                    if (ds.Tables["Utilizador"].Rows[0]["activo"].ToString() == "True")
                    {
                        return (bool)ds.Tables["Utilizador"].Rows[0]["Supervisor"]? TipoUtilizador.SUPERVISOR : TipoUtilizador.OPERADOR;
                    }
                }
                return TipoUtilizador.DESCONHECIDO;
            */
        }
    }
}
